
'********************************************************************************* 
'                                 EXPLANATION OF TERMS
'********************************************************************************* 
'  PROCEDURE
'     The term procedure is an umbrella term that can refer to a function procedure
'     (function) or a sub-procedure. (Microsoft)
'
'     (1) FUNCTION PROCEDURE (or FUNCTION)
'         When a function is called it performs some procedure and always
'         returns a value when the procedure ends.
'     (2) SUB-PROCEDURE
'         When a sub-procedure is called, it too performs some procedure, but it
'         does not return a value when the procedure ends.
'
'PUB and PRI are both procedures.  Since they both return values, they are a
'special type of procedure, a procedure called a "function procedure" or just
'a function. 
' 
'In previous examples in this series of examples, PUB and PRI were called
'procedures.  I did this to keep the reader from looking for a return value
'which is necessary with a function.  There was a return value but it
'could not be seen by the reader. When you get the documentation, you
'can dive deeper into this subject. In example 10, there will be an
'explicit return value.
'*********************************************************************************
'*********************************************************************************
'In the future, PUB and PRI will be referred to as functions.
'*********************************************************************************
'*********************************************************************************
'NOTE: No attempt was made to cover all the variations of the above terms. 
'      Only Microsoft's thinking was given. Event procedures were not covered.
'*********************************************************************************
'
'
'
'
'                                     EXAMPLE 10
'
'            HOW TO CODE A FUNCTION THAT FINDS THE LARGEST OF TWO VALUES                      
'*********************************************************************************  
'IMPORTANT: This example may require an understanding of examples 04, 05, and 06.
'*********************************************************************************
'WHAT'S NEW IN THIS EXAMPLE:
'
'     FUNCTION: A function is a type of procedure that returns a value. A function
'               is often called a function procedure.
'
'*********************************************************************************  
'DIFFICULTY LEVEL: Intermediate
'
'PURPOSE: This code demonstrates how to code a function.  This function will return
'         the largest of two values.
'
'Submitted by Dave Scanlan, March 15, 2006         
'File: Example10_FunctionFindLargestVer1.spin
'*********************************************************************************
'CORRECT OUTPUT:  The largest value (10) will be displayed on the video monitor.
'*********************************************************************************
CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
' 
VAR
'No global variables used.
'
OBJ
  VideoDisplay: "TV_Terminal"            
'
PUB Start | X, Y, LargestValue        'X, Y, and LargestValue are Local variables.
  VideoDisplay.Start
  SetScreenToWhiteOnDarkBlue
'
  X := 5
  Y := 10
' 
  LargestValue := FindTheLargest(X,Y) 'Calls the function and assigns the
'                                      result to "LargestValue."
  VideoDisplay.Dec(LargestValue)
'
PRI FindTheLargest (X,Y) | Largest     'Declares the function.
  If X > Y
    Largest := X
  Else
    Largest := Y
'
  Result := Largest                    '"Result" is a Spin reserved word and is the 
'                                        location use to return the result of the 
'                                        function.
PRI SetScreenToWhiteOnDarkBlue                  
  VideoDisplay.Out(3)                           
  VideoDisplay.Out(5)
'
'
'ADDITIONAL INFORMATION ON HOW THIS FUNCTION WORKS:
'  PRI FindTheLargest (X,Y)
'     -- This is the declaration of the function called "FindTheLargest".
'     -- The X and Y are parameters.
'     -- The Spin reserved word "Result" is a location used to return
'        the result of the function.
'
'  LargestValue := FindTheLargest(X,Y)
'    -- This statement calls the function and passes the arguments, X(5)and Y(10),
'       to their corresponding parameters in the function.
'    -- The code in the function is executed and the result is stored in
'       the location called "Result"
'    -- In the final step, the value stored in the location called "Result"  
'       is assigned to "LargestValue" although this final step is not obvious.
'       A way to conceptualize the assignment is: LargestValue := Result.